﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.Mvc
Imports MicroBloggingAzure.Models

Namespace MicroBloggingAzure.Controllers
	Public Class IndexViewData
		Private privateMessages As IEnumerable(Of Message)
		Public Property Messages() As IEnumerable(Of Message)
			Get
				Return privateMessages
			End Get
			Set(ByVal value As IEnumerable(Of Message))
				privateMessages = value
			End Set
		End Property
		Private privateChannels As IEnumerable(Of Channel)
		Public Property Channels() As IEnumerable(Of Channel)
			Get
				Return privateChannels
			End Get
			Set(ByVal value As IEnumerable(Of Channel))
				privateChannels = value
			End Set
		End Property
	End Class

	<HandleError> _
	Public Class HomeController
		Inherits Controller
		Public Function Index(ByVal channel As String, ByVal author As String) As ActionResult
			Dim svc = New Models.MicroData()
			ViewData("channels") = svc.Channels

			Dim q = _
				From m In svc.Messages _
				Where m.PartitionKey = Models.Message.MakeKey(channel, DateTime.UtcNow) _
				Select m
			If (Not String.IsNullOrEmpty(author)) Then
				q = _
					From m In q _
					Where m.Author = author _
					Select m
			End If

			ViewData("msg") = q

			Return View()
		End Function
		Public Function Message() As ActionResult
			Return View()
		End Function

		<AcceptVerbs("POST")> _
		Public Function PostMessage(ByVal channel As String, ByVal author As String, ByVal msg As String) As ActionResult
			Dim svc = New Models.MicroData()

			Dim q = _
				From c In svc.Channels _
				Where c.PartitionKey = channel _
				Select c

			If q.FirstOrDefault() Is Nothing Then
				Throw New ArgumentException("Invalid channel")
			End If

			Dim u As User = ( _
					From auth In svc.Users _
					Where auth.UserName = author _
					Select auth).FirstOrDefault()

			If u Is Nothing Then 'throw new ArgumentException("Invalid Author");
				Dim user = New User()
				user.UserName = author
				user.DateCreated = DateTime.UtcNow
				user.PartitionKey = user.UserName
				user.RowKey = String.Empty
				svc.AddObject("Users", user)
				u = user
			End If

			Dim m = New Models.Message(channel, author, msg)
			svc.AddObject("Messages", m)

			svc.SaveChanges()

			Return Me.RedirectToAction("Index")
		End Function
		Public Function Channel() As ActionResult
			Dim svc = New Models.MicroData()
			ViewData("channels") = svc.Channels

			Return View()
		End Function
		<AcceptVerbs("POST")> _
		Public Function CreateChannel(ByVal name As String) As ActionResult
			Dim svc = New Models.MicroData()
			Dim chan As Channel = ( _
					From c In svc.Channels _
					Where c.ChannelName = name _
					Select c).FirstOrDefault()


			If chan IsNot Nothing Then
				Throw New ArgumentException("Channel Already Exists.")
			End If

			Dim ch = New Channel()
			ch.ChannelName = name
			ch.DateCreated = DateTime.UtcNow
			ch.PartitionKey = ch.ChannelName
			ch.RowKey = String.Empty

			svc.AddObject("Channels", ch)
			svc.SaveChanges()

			Return Me.RedirectToAction("Index")
		End Function
		Public Function About() As ActionResult
			ViewData("Title") = "About Page"

			Return View()
		End Function


	End Class
End Namespace
