﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Data.Services.Common
Imports Microsoft.Samples.ServiceHosting.StorageClient

Namespace MicroBloggingAzure.Models
	<DataServiceKey("PartitionKey", "RowKey")> _
	Public Class Channel
		' the channel name
		Private privatePartitionKey As String
		Public Property PartitionKey() As String
			Get
				Return privatePartitionKey
			End Get
			Set(ByVal value As String)
				privatePartitionKey = value
			End Set
		End Property
		Private privateRowKey As String
		Public Property RowKey() As String
			Get
				Return privateRowKey
			End Get
			Set(ByVal value As String)
				privateRowKey = value
			End Set
		End Property

		Private privateChannelName As String
		Public Property ChannelName() As String
			Get
				Return privateChannelName
			End Get
			Set(ByVal value As String)
				privateChannelName = value
			End Set
		End Property
		Private privateDateCreated As DateTime
		Public Property DateCreated() As DateTime
			Get
				Return privateDateCreated
			End Get
			Set(ByVal value As DateTime)
				privateDateCreated = value
			End Set
		End Property

		Public Sub New()
		End Sub

		Public Sub New(ByVal name As String)
			Me.ChannelName = name
			Me.DateCreated = DateTime.UtcNow
			Me.PartitionKey = ChannelName
			Me.RowKey = String.Empty
		End Sub
	End Class

	<DataServiceKey("PartitionKey", "RowKey")> _
	Public Class Message
		' ParitionKey is channel name [+ day]
		Private privatePartitionKey As String
		Public Property PartitionKey() As String
			Get
				Return privatePartitionKey
			End Get
			Set(ByVal value As String)
				privatePartitionKey = value
			End Set
		End Property
		' Date/Time when the message was created
		Private privateRowKey As String
		Public Property RowKey() As String
			Get
				Return privateRowKey
			End Get
			Set(ByVal value As String)
				privateRowKey = value
			End Set
		End Property

		Private privateText As String
		Public Property Text() As String
			Get
				Return privateText
			End Get
			Set(ByVal value As String)
				privateText = value
			End Set
		End Property
		Private privateAuthor As String
		Public Property Author() As String
			Get
				Return privateAuthor
			End Get
			Set(ByVal value As String)
				privateAuthor = value
			End Set
		End Property
		Private privateChannel As String
		Public Property Channel() As String
			Get
				Return privateChannel
			End Get
			Set(ByVal value As String)
				privateChannel = value
			End Set
		End Property
		Private privateDatePosted As DateTime
		Public Property DatePosted() As DateTime
			Get
				Return privateDatePosted
			End Get
			Set(ByVal value As DateTime)
				privateDatePosted = value
			End Set
		End Property
		Private privateRating As Integer
		Public Property Rating() As Integer
			Get
				Return privateRating
			End Get
			Set(ByVal value As Integer)
				privateRating = value
			End Set
		End Property

		Public Sub New()
		End Sub

		Public Sub New(ByVal channel As String, ByVal author As String, ByVal text As String)
			Me.Text = text
			Me.Author = author
			Me.Channel = channel
			Me.DatePosted = DateTime.UtcNow

			Me.PartitionKey = MakeKey(Me.Channel, Me.DatePosted)
			Me.RowKey = System.Xml.XmlConvert.ToString(Me.DatePosted)
		End Sub

		Public Shared Function MakeKey(ByVal channel As String, ByVal dt As DateTime) As String
			Return channel & "@" & dt.ToString("yyyy-MM-dd")
		End Function
	End Class

	<DataServiceKey("PartitionKey", "RowKey")> _
	Public Class User
		' the username
		Private privatePartitionKey As String
		Public Property PartitionKey() As String
			Get
				Return privatePartitionKey
			End Get
			Set(ByVal value As String)
				privatePartitionKey = value
			End Set
		End Property
		Private privateRowKey As String
		Public Property RowKey() As String
			Get
				Return privateRowKey
			End Get
			Set(ByVal value As String)
				privateRowKey = value
			End Set
		End Property

		Private privateUserName As String
		Public Property UserName() As String
			Get
				Return privateUserName
			End Get
			Set(ByVal value As String)
				privateUserName = value
			End Set
		End Property
		Private privateDateCreated As DateTime
		Public Property DateCreated() As DateTime
			Get
				Return privateDateCreated
			End Get
			Set(ByVal value As DateTime)
				privateDateCreated = value
			End Set
		End Property


		Public Sub New()
		End Sub

		Public Sub New(ByVal name As String)
			Me.DateCreated = DateTime.UtcNow
			Me.UserName = name
			Me.PartitionKey = UserName
			Me.RowKey = String.Empty

		End Sub
	End Class

	Public Class MicroData
		Inherits TableStorageDataServiceContext
		Public ReadOnly Property Channels() As IQueryable(Of Channel)
			Get
				Return Me.CreateQuery(Of Channel)("Channels")
			End Get
		End Property
		Public ReadOnly Property Messages() As IQueryable(Of Message)
			Get
				Return Me.CreateQuery(Of Message)("Messages")
			End Get
		End Property
		Public ReadOnly Property Users() As IQueryable(Of User)
			Get
				Return Me.CreateQuery(Of User)("Users")
			End Get
		End Property
	End Class
End Namespace
