﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.Mvc
Imports MicroBloggingOnPremise.Models
Imports System.Data.Services.Client

Namespace MicroBloggingOnPremise.Controllers
	<HandleError> _
	Public Class HomeController
		Inherits Controller
		Public Function Index(ByVal channel As String, ByVal author As String) As ActionResult
			Dim svc As New microblogEntities(New Uri("http://localhost:50396/MicroData.svc"))
			ViewData("channels") = svc.Channels

			Dim y As Integer = DateTime.Now.Year
			Dim mm As Integer = DateTime.Now.Month
			Dim d As Integer = DateTime.Now.Day

			Dim q = _
				From m In svc.Messages.Expand("Author").Expand("Channel") _
				Where m.Channel.ChannelName = channel AndAlso (m.DatePosted.Year = y AndAlso m.DatePosted.Month = mm AndAlso m.DatePosted.Day = d) _
				Select m

			If (Not String.IsNullOrEmpty(author)) Then
				q = _
					From m In q _
					Where m.Author.UserName = author _
					Select m
			End If

			ViewData("msg") = q

			Return View()
		End Function

		Public Function Message() As ActionResult
			Return View()
		End Function
		<AcceptVerbs("POST")> _
		Public Function PostMessage(ByVal channel As String, ByVal author As String, ByVal msg As String) As ActionResult
			Dim svc As New microblogEntities(New Uri("http://localhost:50396/MicroData.svc"))

			Dim chan As Channel = ( _
					From c In svc.Channels _
					Where c.ChannelName = channel _
					Select c).FirstOrDefault()


			If chan Is Nothing Then
				Throw New ArgumentException("Invalid channel")
			End If

			Dim u As User = ( _
					From auth In svc.Users _
					Where auth.UserName = author _
					Select auth).FirstOrDefault()

			If u Is Nothing Then 'throw new ArgumentException("Invalid Author");
				'To simplify this example we will create a new user, if the user was null when we queried. 
				'It is possible that another client creates the same UserName before we call SaveChanges() 
				'and we end up with 2 Users with the same name
				Dim user = New User()
				user.UserName = author
				user.DateCreated = DateTime.UtcNow
				svc.AddToUsers(user)
				u = user

			End If


			Dim m = New Message()

			m.DatePosted = DateTime.UtcNow
			m.Text = msg
			svc.AddToMessages(m)
			svc.SetLink(m, "Channel", chan)
			svc.SetLink(m, "Author", u)

			Try
				svc.SaveChanges()
			Catch e As Exception
				Throw (e)
			End Try
			Return Me.RedirectToAction("Index")
		End Function
		Public Function Channel() As ActionResult
			Dim svc As New microblogEntities(New Uri("http://localhost:50396/MicroData.svc"))
			ViewData("channels") = svc.Channels
			Return View()
		End Function
		<AcceptVerbs("POST")> _
		Public Function CreateChannel(ByVal name As String) As ActionResult
			Dim svc As New microblogEntities(New Uri("http://localhost:50396/MicroData.svc"))

			Dim q = _
				From c In svc.Channels _
				Where c.ChannelName = name _
				Select c
			Dim chan As Channel = q.FirstOrDefault()

			If chan IsNot Nothing Then
				Throw New ArgumentException("Channel Already Exists.")
			End If

			'To simplify this example we will create a new channel, if the channel            
			'was null when we queried. 
			'It is possible that another client creates the same channel 
			'before we call SaveChanges() and we end up with 2 Channels with the 
			'same name
			Dim ch = New Channel()
			ch.ChannelName = name
			ch.DateCreated = DateTime.UtcNow

			svc.AddToChannels(ch)
			svc.SaveChanges()

			Return Me.RedirectToAction("Index")
		End Function

		Public Function About() As ActionResult
			Return View()
		End Function
	End Class
End Namespace
